package com.sa.ibiz.demo.demo.service.dto;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.ibizutil.domain.ParentData;
import com.sa.ibiz.demo.demo.domain.ZB;
import org.springframework.util.StringUtils;
import lombok.Data;
import java.util.Map;
import java.sql.Timestamp;
import com.sa.ibiz.demo.ibizutil.service.SearchFilterBase;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.sa.ibiz.demo.ibizutil.helper.DataGridCustomSearchHelper;
import com.alibaba.fastjson.JSONObject;
@Data
@JsonIgnoreProperties(ignoreUnknown = true)
public class ZBSearchFilter extends SearchFilterBase {

	private String query;
	private Page page;
	private QueryWrapper<ZB> selectCond;
	private JSONObject customsearchval;
	public ZBSearchFilter(){
		this.page =new Page<ZB>(1,Short.MAX_VALUE);
		this.selectCond=new QueryWrapper<ZB>();	
	}

	/**
	 * 设定自定义查询条件，在原有SQL基础上追加该SQL
	 */
	public void setCustomCond(String sql)
	{
		this.selectCond.apply(sql);
	}

	private String n_orguserid_eq;

	public void setN_orguserid_eq(String n_orguserid_eq) {
        this.n_orguserid_eq = n_orguserid_eq;
        if(!StringUtils.isEmpty(this.n_orguserid_eq)){
            this.selectCond.eq("orguserid", n_orguserid_eq);
        }
    }
	private String n_orgusername_eq;

	public void setN_orgusername_eq(String n_orgusername_eq) {
        this.n_orgusername_eq = n_orgusername_eq;
        if(!StringUtils.isEmpty(this.n_orgusername_eq)){
            this.selectCond.eq("orgusername", n_orgusername_eq);
        }
    }
	private String n_orgusername_like;

	public void setN_orgusername_like(String n_orgusername_like) {
        this.n_orgusername_like = n_orgusername_like;
        if(!StringUtils.isEmpty(this.n_orgusername_like)){
            this.selectCond.like("orgusername", n_orgusername_like);
        }
    }
	private String n_zbname_like;

	public void setN_zbname_like(String n_zbname_like) {
        this.n_zbname_like = n_zbname_like;
        if(!StringUtils.isEmpty(this.n_zbname_like)){
            this.selectCond.like("zbname", n_zbname_like);
        }
    }

	public void setSrfparentdata(Map<String, String> srfparentdata) {
		this.srfparentdata = srfparentdata;
		String strParentkey=this.getSrfparentdata().get("srfparentkey");
		if(this.srfparentdata.containsKey("srfparentmode")&& this.getSrfparentdata().get("srfparentmode").equals("DER1N_ZB_ORGUSER_ORGUSERID"))
			if(StringUtils.isEmpty(strParentkey)){
				this.setN_orguserid_eq("NA");
			}
			else{
				this.setN_orguserid_eq(strParentkey);
			}
	}

	/**
	 * 启用快速搜索
	 */
	public void setQuery(String query)
	{
		 this.query=query;
		 if(!StringUtils.isEmpty(query)){
			this.selectCond.or().like("zbname",query);
		 }
	}

	/**
	 * 自定义查询
	 * @param customsearchval
	 */
	public void setCustomsearchval(JSONObject customsearchval) {
		this.customsearchval = customsearchval;
		if(!StringUtils.isEmpty(customsearchval)){
			DataGridCustomSearchHelper customSearchHelper= DataGridCustomSearchHelper.getInstance();
			String customSql =customSearchHelper.parseCustomVal(customsearchval);
			this.selectCond.apply(customSql);
		}
	}

}